'*****************************************************************************
'*                       BRT-1 V1.0.1                  *
'* Chip:  ATMEGA 128                                                         *
'* Freq:  1.8432 Mhz                                                         *
'* Autor:  ..      14  2008 .                           *
'*****************************************************************************

$regfile = "m16def.dat"                                     '   
$crystal = 1843200
$baud = 9600                                                '   COM1
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 8                                                ' default use 8 for the SW stack
$framesize = 24                                             ' default use 24 for the frame space

Declare Sub Findtermo
Declare Sub Gettemper

$lib "i2c_twi.lbx"                                          '  TWI

' 
Dim T_int As Byte , Key_int As Byte
Dim Error As Byte
Dim I As Byte
Dim T As Single , Tw As Word , Tind As Word
Dim D1 As Byte , D2 As Single , D3 As Word , D4 As Single
Dim Str1 As String * 3 , Str2 As String * 3 , Str3 As String * 5
Dim S(5) As Byte , A(4) As Byte
Dim Key As Byte
Dim Tmp As Byte

Const Scanw = &HC0
Const Scanr = &HC1
Const Configreg = &H04

Config Com1 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0

Config 1wire = Portb.7
Termopin Alias Pinb.7

Config Porta = &B00000111
Ledh Alias Porta.0
Ledn Alias Porta.1
Ledl Alias Porta.2

Config Scl = Portc.0
Config Sda = Portc.1
I2cinit

Config Timer1 = Timer , Prescale = 8
Stop Timer1
Timer1 = 0

Disable Interrupts
On Int0 Kbd_int Nosave
On Timer1 Timer_int Nosave
Config Int0 = Rising
Enable Int0
Enable Timer1

' 
Set Ledh : Set Ledn : Set Ledl

'  5 
I2cstart
I2cwbyte Scanw
I2cwbyte &H03
I2cwbyte &H04
I2cstop
'  
I2cstart
I2cwbyte Scanw
I2cwbyte &H02
I2cwbyte &H0F
I2cstop
' 
I2cstart
I2cwbyte Scanw
I2cwbyte &H07
I2cwbyte &H01
I2cstop
Wait 1
' 
I2cstart
I2cwbyte Scanw
I2cwbyte &H06
I2cwbyte &H80
I2cstop
I2cstart
I2cwbyte Scanw
I2cwbyte &H08
I2cwbyte &H01
I2cwbyte &H01
I2cwbyte &H01
I2cwbyte &H01
I2cstop

'   
 S(1) = 40 : S(2) = 20 : S(3) = &H7F
 1wreset
 1wwrite &HCC
 1wwrite &H4E
 1wwrite S(1) , 3
'   EEPROM
 1wreset
 1wwrite &HCC
 1wwrite &H48

Error = 0 : T_int = 0 : Key_int = 0

Find:
 Disable Interrupts
 Stop Timer1
 Timer1 = 0
 Call Findtermo
 If Error = 1 Then                                          '  
   Waitms 300
    Goto Find
 End If

Enable Interrupts
Start Timer1

Main:
'  
If Key_int <> 0 Then
 Key_int = 0
  I2cstart                                                  'generate start
  I2cwbyte Scanw                                            'slave adsress
  I2cwbyte &H0C                                             'address of EEPROM
  I2cstart                                                  'repeated start
  I2cwbyte Scanr                                            'slave address (read)
  For I = 1 To 3
   I2crbyte S(i) , Ack
  Next
  I2crbyte S(4) , Nack
  I2cstop
Print "KeyPressed"
For I = 1 To 4
 Print Bin(s(i))
Next
'   
 I2cstart                                                   'generate start
  I2cwbyte Scanw                                            'slave adsress
  I2cwbyte &H08                                             'address of EEPROM
  I2cstart                                                  'repeated start
  I2cwbyte Scanr
  For I = 1 To 3
   I2crbyte Tmp , Ack
  Next                                                      'slave address (read)
  I2crbyte Tmp , Nack
  I2cstop
Goto Main
End If

'  
If T_int <> 0 Then
 T_int = 0
 Call Findtermo
  If Error = 1 Then Goto Find
 Stop Timer1
 Timer1 = 0
 Call Gettemper
'  
 1wreset
 1wwrite &HEC
 S(1) = 1wread(1 , Pinb , 7)
' 
If S(1) = &HFE Then
  If Tw > A(3) Then
    Set Ledh : Reset Ledn : Reset Ledl
  End If
  If Tw < A(4) Then
    Reset Ledh : Reset Ledn : Set Ledl
  End If
Else
    Reset Ledh : Set Ledn : Reset Ledl
End If
'    
 D1 = Int(t)                                                '    
 D2 = Frac(t)                                               '  
  If D1 >= 100 Then                                         '  >100 
   D2 = D2 * 100                                            '    
  Else                                                      '
   D2 = D2 * 1000                                           ' 
  End If
 D3 = Int(d2)
 D4 = Frac(d2)
  If D4 > 0.49 Then D3 = D3 + 1                             ' 
 Str1 = Str(d1) : Str2 = Str(d3)
 Str3 = Str1 + Str2
'    
 For I = 1 To 5
  Str1 = Mid(str3 , I , 1)
  S(i) = Val(str1)
 Next
'  
 If D1 >= 100 Then
  S(3) = S(3) Or &H80
 Else
  S(2) = S(2) Or &H80
 End If
'  
 I2cstart
 I2cwbyte Scanw
 I2cwbyte &H20
  For I = 5 To 1 Step -1
   I2cwbyte S(i)
  Next
 I2cstop
 Start Timer1
Goto Main
End If

Idle
Goto Main

Stop
'==========================  ====================================
Kbd_int:
 push r24
  Key_int = 1
 pop r24
Return

Timer_int:
 push r24
  T_int = 1
 pop r24
Return

Sub Findtermo
' 
 1wreset
 If Err = 1 Then                                            '      
  Error = 1
  I2cstart
  I2cwbyte Scanw
  I2cwbyte Configreg
  I2cwbyte &H2D
  I2cstop
'   ERR
S(3) = 10 : S(2) = 10 : S(1) = 14
 I2cstart
 I2cwbyte Scanw
 I2cwbyte &H20
  For I = 3 To 1 Step -1
   I2cwbyte S(i)
  Next
 I2cstop
 Else                                                       '    
  Error = 0
'  
I2cstart
I2cwbyte Scanw
I2cwbyte &H07
I2cwbyte &H00
I2cstop
  I2cstart
  I2cwbyte Scanw
  I2cwbyte Configreg
  I2cwbyte &H21
  I2cstop
 End If
End Sub

' 
Sub Gettemper                                               ' actual measuring
   1wreset                                                  ' reset the bus
   1wwrite &HCC                                             ' skip rom
   1wwrite &H44                                             ' Convert T
   Bitwait Termopin , Set
   1wreset
   1wwrite &HCC                                             ' reset the bus
   1wwrite &HBE                                             ' read 2 data bytest
   A(1) = 1wread(4 , Pinb , 7)
   Tw = Makeint(a(1) , A(2))
   Tw = Tw / 16
   1wreset
   1wwrite &HCC                                             ' reset the bus
   1wwrite &HBE                                             ' read 2 data bytest
   Tind = 1wread(2 , Pinb , 7)
   T = Tind / 16
End Sub